diff --git a/internal/telemetry/sensitivemetadataallowlist/redact_test.go b/internal/telemetry/sensitivemetadataallowlist/redact_test.go
new file mode 100644
index 00000000000..6996008c9f5
--- /dev/null
+++ b/internal/telemetry/sensitivemetadataallowlist/redact_test.go
@@ -0,0 +1,79 @@
+package sensitivemetadataallowlist
+
+import (
+	"testing"
+
+	"github.com/stretchr/testify/assert"
+	"google.golang.org/protobuf/types/known/structpb"
+
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+	"github.com/sourcegraph/sourcegraph/lib/pointers"
+)
+
+func TestRedactEvent(t *testing.T) {
+	makeFullEvent := func() *telemetrygatewayv1.Event {
+		return &telemetrygatewayv1.Event{
+			Parameters: &telemetrygatewayv1.EventParameters{
+				PrivateMetadata: &structpb.Struct{
+					Fields: map[string]*structpb.Value{
+						"testField": structpb.NewBoolValue(true),
+					},
+				},
+			},
+			MarketingTracking: &telemetrygatewayv1.EventMarketingTracking{
+				Url: pointers.Ptr("sourcegraph.com"),
+			},
+		}
+	}
+
+	tests := []struct {
+		name   string
+		mode   redactMode
+		event  *telemetrygatewayv1.Event
+		assert func(t *testing.T, got *telemetrygatewayv1.Event)
+	}{
+		{
+			name:  "redact all sensitive",
+			mode:  redactAllSensitive,
+			event: makeFullEvent(),
+			assert: func(t *testing.T, got *telemetrygatewayv1.Event) {
+				assert.Nil(t, got.Parameters.PrivateMetadata)
+				assert.Nil(t, got.MarketingTracking)
+			},
+		},
+		{
+			name:  "redact all sensitive on empty event",
+			mode:  redactAllSensitive,
+			event: &telemetrygatewayv1.Event{},
+			assert: func(t *testing.T, got *telemetrygatewayv1.Event) {
+				assert.Nil(t, got.Parameters.PrivateMetadata)
+				assert.Nil(t, got.MarketingTracking)
+			},
+		},
+		{
+			name:  "redact marketing",
+			mode:  redactMarketing,
+			event: makeFullEvent(),
+			assert: func(t *testing.T, got *telemetrygatewayv1.Event) {
+				assert.NotNil(t, got.Parameters.PrivateMetadata)
+				assert.Nil(t, got.MarketingTracking)
+			},
+		},
+		{
+			name:  "redact nothing",
+			mode:  redactNothing,
+			event: makeFullEvent(),
+			assert: func(t *testing.T, got *telemetrygatewayv1.Event) {
+				assert.NotNil(t, got.Parameters.PrivateMetadata)
+				assert.NotNil(t, got.MarketingTracking)
+			},
+		},
+	}
+	for _, tc := range tests {
+		t.Run(tc.name, func(t *testing.T) {
+			ev := makeFullEvent()
+			redactEvent(ev, tc.mode)
+			tc.assert(t, ev)
+		})
+	}
+}
diff --git a/internal/telemetry/sensitivemetadataallowlist/sensitivemetadataallowlist_test.go b/internal/telemetry/sensitivemetadataallowlist/sensitivemetadataallowlist_test.go
new file mode 100644
index 00000000000..b38340aa812
--- /dev/null
+++ b/internal/telemetry/sensitivemetadataallowlist/sensitivemetadataallowlist_test.go
@@ -0,0 +1,24 @@
+package sensitivemetadataallowlist
+
+import (
+	"testing"
+
+	"github.com/stretchr/testify/assert"
+	"github.com/stretchr/testify/require"
+
+	"github.com/sourcegraph/sourcegraph/internal/telemetry"
+	v1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+)
+
+func TestIsAllowed(t *testing.T) {
+	allowedTypes := AllowedEventTypes()
+	require.NotEmpty(t, allowedTypes)
+	assert.True(t, allowedTypes.IsAllowed(&v1.Event{
+		Feature: string(telemetry.FeatureExample),
+		Action:  string(telemetry.ActionExample),
+	}))
+	assert.False(t, allowedTypes.IsAllowed(&v1.Event{
+		Feature: "disallowedFeature",
+		Action:  "disallowedAction",
+	}))
+}
diff --git a/internal/telemetry/sensitivemetadataallowlist/sensitiviemetadataallowlist.go b/internal/telemetry/sensitivemetadataallowlist/sensitiviemetadataallowlist.go
new file mode 100644
index 00000000000..6df601b2c09
--- /dev/null
+++ b/internal/telemetry/sensitivemetadataallowlist/sensitiviemetadataallowlist.go
@@ -0,0 +1,87 @@
+package sensitivemetadataallowlist
+
+import (
+	"fmt"
+
+	"github.com/sourcegraph/sourcegraph/cmd/frontend/envvar"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+
+	"github.com/sourcegraph/sourcegraph/internal/telemetry"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+)
+
+// AllowedEventTypes denotes a list of all events allowed to export sensitive
+// telemetry metadata.
+func AllowedEventTypes() EventTypes {
+	return eventTypes(
+		// Example event for testing.
+		EventType{
+			Feature: string(telemetry.FeatureExample),
+			Action:  string(telemetry.ActionExample),
+		},
+	)
+}
+
+type EventTypes struct {
+	types []EventType
+	// index of '{feature}.{action}' for checking
+	index map[string]struct{}
+}
+
+func eventTypes(types ...EventType) EventTypes {
+	index := make(map[string]struct{}, len(types))
+	for _, t := range types {
+		index[fmt.Sprintf("%s.%s", t.Feature, t.Action)] = struct{}{}
+	}
+	return EventTypes{types: types, index: index}
+}
+
+// Redact strips the event of sensitive data based on the allowlist.
+//
+// 🚨 SECURITY: Be very careful with the redaction modes used here, as it impacts
+// what data we export from customer Sourcegraph instances.
+func (e EventTypes) Redact(event *telemetrygatewayv1.Event) {
+	rm := redactAllSensitive
+	if envvar.SourcegraphDotComMode() {
+		rm = redactNothing
+	} else if e.IsAllowed(event) {
+		rm = redactMarketing
+	}
+	redactEvent(event, rm)
+}
+
+// IsAllowed indicates an event is on the sensitive telemetry allowlist.
+func (e EventTypes) IsAllowed(event *telemetrygatewayv1.Event) bool {
+	key := fmt.Sprintf("%s.%s", event.GetFeature(), event.GetAction())
+	_, allowed := e.index[key]
+	return allowed
+}
+
+func (e EventTypes) validate() error {
+	for _, t := range e.types {
+		if err := t.validate(); err != nil {
+			return err
+		}
+	}
+	return nil
+}
+
+type EventType struct {
+	Feature string
+	Action  string
+
+	// Future: maybe restrict to specific, known private metadata fields as well
+}
+
+func (e EventType) validate() error {
+	if e.Feature == "" || e.Action == "" {
+		return errors.New("feature and action are required")
+	}
+	return nil
+}
+
+func init() {
+	if err := AllowedEventTypes().validate(); err != nil {
+		panic(errors.Wrap(err, "AllowedEvents has invalid event(s)"))
+	}
+}
diff --git a/internal/telemetry/teestore/BUILD.bazel b/internal/telemetry/teestore/BUILD.bazel
index 5895bbb925c..7b3cff9ba69 100644
--- a/internal/telemetry/teestore/BUILD.bazel
+++ b/internal/telemetry/teestore/BUILD.bazel
@@ -3,12 +3,16 @@ load("//dev:go_defs.bzl", "go_test")
 
 go_library(
     name = "teestore",
-    srcs = ["teestore.go"],
+    srcs = [
+        "option.go",
+        "teestore.go",
+    ],
     importpath = "github.com/sourcegraph/sourcegraph/internal/telemetry/teestore",
     visibility = ["//:__subpackages__"],
     deps = [
         "//internal/database",
         "//internal/featureflag",
+        "//internal/telemetry/sensitivemetadataallowlist",
         "//internal/telemetrygateway/v1:telemetrygateway",
         "//lib/errors",
         "//lib/pointers",
diff --git a/internal/telemetry/teestore/option.go b/internal/telemetry/teestore/option.go
new file mode 100644
index 00000000000..5bc4c53c182
--- /dev/null
+++ b/internal/telemetry/teestore/option.go
@@ -0,0 +1,21 @@
+package teestore
+
+import "context"
+
+type contextKey int
+
+const withoutV1Key contextKey = iota
+
+// WithoutV1 adds a special flag to context that indicates to an underlying
+// events teestore.Store that it should not persist the event as a V1 event.
+//
+// This is useful for callsites where the shape of the legacy event must be
+// preserved, such that it continues to be logged manually.
+func WithoutV1(ctx context.Context) context.Context {
+	return context.WithValue(ctx, withoutV1Key, true)
+}
+
+func shouldDisableV1(ctx context.Context) bool {
+	v, ok := ctx.Value(withoutV1Key).(bool)
+	return ok && v
+}
diff --git a/internal/telemetry/teestore/teestore.go b/internal/telemetry/teestore/teestore.go
index 7325b16b822..cf55ff15e97 100644
--- a/internal/telemetry/teestore/teestore.go
+++ b/internal/telemetry/teestore/teestore.go
@@ -11,6 +11,7 @@ import (
 
 	"github.com/sourcegraph/sourcegraph/internal/database"
 	"github.com/sourcegraph/sourcegraph/internal/featureflag"
+	"github.com/sourcegraph/sourcegraph/internal/telemetry/sensitivemetadataallowlist"
 	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
 	"github.com/sourcegraph/sourcegraph/lib/errors"
 	"github.com/sourcegraph/sourcegraph/lib/pointers"
@@ -19,20 +20,16 @@ import (
 // Store tees events into both the event_logs table and the new telemetry export
 // queue, translating the message into the existing event_logs format on a
 // best-effort basis.
-type Store interface {
-	StoreEvents(context.Context, []*telemetrygatewayv1.Event) error
-}
-
-type store struct {
+type Store struct {
 	exportQueue database.TelemetryEventsExportQueueStore
 	eventLogs   database.EventLogStore
 }
 
-func NewStore(exportQueue database.TelemetryEventsExportQueueStore, eventLogs database.EventLogStore) Store {
-	return &store{exportQueue, eventLogs}
+func NewStore(exportQueue database.TelemetryEventsExportQueueStore, eventLogs database.EventLogStore) *Store {
+	return &Store{exportQueue, eventLogs}
 }
 
-func (s *store) StoreEvents(ctx context.Context, events []*telemetrygatewayv1.Event) error {
+func (s *Store) StoreEvents(ctx context.Context, events []*telemetrygatewayv1.Event) error {
 	// Write to both stores at the same time.
 	wg := pool.New().WithErrors()
 	wg.Go(func() error {
@@ -41,16 +38,20 @@ func (s *store) StoreEvents(ctx context.Context, events []*telemetrygatewayv1.Ev
 		}
 		return nil
 	})
-	wg.Go(func() error {
-		if err := s.eventLogs.BulkInsert(ctx, toEventLogs(time.Now, events)); err != nil {
-			return errors.Wrap(err, "bulk inserting events logs")
-		}
-		return nil
-	})
+	if !shouldDisableV1(ctx) {
+		wg.Go(func() error {
+			if err := s.eventLogs.BulkInsert(ctx, toEventLogs(time.Now, events)); err != nil {
+				return errors.Wrap(err, "bulk inserting events logs")
+			}
+			return nil
+		})
+	}
 	return wg.Wait()
 }
 
 func toEventLogs(now func() time.Time, telemetryEvents []*telemetrygatewayv1.Event) []*database.Event {
+	sensitiveMetadataAllowlist := sensitivemetadataallowlist.AllowedEventTypes()
+
 	eventLogs := make([]*database.Event, len(telemetryEvents))
 	for i, e := range telemetryEvents {
 		// Note that all generated proto getters are nil-safe, so use those to
@@ -60,7 +61,7 @@ func toEventLogs(now func() time.Time, telemetryEvents []*telemetrygatewayv1.Eve
 			InsertID: nil, // not required on insert
 
 			// Identifiers
-			Name: fmt.Sprintf("%s%s.%s", maybeSourceEventNamePrefix(e.GetSource()), e.GetFeature(), e.GetAction()),
+			Name: fmt.Sprintf("V2:%s.%s", e.GetFeature(), e.GetAction()),
 			Timestamp: func() time.Time {
 				if e.GetTimestamp() == nil {
 					return now()
@@ -91,6 +92,11 @@ func toEventLogs(now func() time.Time, telemetryEvents []*telemetrygatewayv1.Eve
 				if len(md) == 0 {
 					return nil
 				}
+
+				// Attach a simple indicator to denote if this metadata will
+				// be exported.
+				md["privateMetadata.export"] = sensitiveMetadataAllowlist.IsAllowed(e)
+
 				data, err := json.Marshal(md)
 				if err != nil {
 					data, _ = json.Marshal(map[string]string{"marshal.error": err.Error()})
@@ -142,10 +148,3 @@ func toEventLogs(now func() time.Time, telemetryEvents []*telemetrygatewayv1.Eve
 	}
 	return eventLogs
 }
-
-func maybeSourceEventNamePrefix(s *telemetrygatewayv1.EventSource) string {
-	if name := s.GetClient().GetName(); name != "" {
-		return name + ":"
-	}
-	return ""
-}
diff --git a/internal/telemetry/teestore/teestore_test.go b/internal/telemetry/teestore/teestore_test.go
index 4fe8b34c52a..de0d9d075a6 100644
--- a/internal/telemetry/teestore/teestore_test.go
+++ b/internal/telemetry/teestore/teestore_test.go
@@ -33,7 +33,7 @@ func TestToEventLogs(t *testing.T) {
 			expectEventLogs: autogold.Expect(`[
   {
     "ID": 0,
-    "Name": ".",
+    "Name": "V2:.",
     "URL": "",
     "UserID": 0,
     "AnonymousUserID": "",
@@ -61,7 +61,7 @@ func TestToEventLogs(t *testing.T) {
 			expectEventLogs: autogold.Expect(`[
   {
     "ID": 0,
-    "Name": ".",
+    "Name": "V2:.",
     "URL": "",
     "UserID": 0,
     "AnonymousUserID": "",
@@ -89,7 +89,7 @@ func TestToEventLogs(t *testing.T) {
 				Id:        "1",
 				Timestamp: timestamppb.New(time.Date(2022, 11, 2, 1, 0, 0, 0, time.UTC)),
 				Feature:   "CodeSearch",
-				Action:    "Seach",
+				Action:    "Search",
 				Source: &telemetrygatewayv1.EventSource{
 					Client: &telemetrygatewayv1.EventSource_Client{
 						Name:    "VSCODE",
@@ -120,12 +120,13 @@ func TestToEventLogs(t *testing.T) {
 			expectEventLogs: autogold.Expect(`[
   {
     "ID": 0,
-    "Name": "VSCODE:CodeSearch.Seach",
+    "Name": "V2:CodeSearch.Search",
     "URL": "sourcegraph.com/foobar",
     "UserID": 1234,
     "AnonymousUserID": "anonymous",
     "Argument": {
-      "private": "sensitive-data"
+      "private": "sensitive-data",
+      "privateMetadata.export": false
     },
     "PublicArgument": {
       "public": 2
diff --git a/internal/telemetry/telemetry.go b/internal/telemetry/telemetry.go
index 3cba49546d0..3b43dac0769 100644
--- a/internal/telemetry/telemetry.go
+++ b/internal/telemetry/telemetry.go
@@ -7,8 +7,6 @@ import (
 	"context"
 	"time"
 
-	"github.com/sourcegraph/sourcegraph/internal/telemetry/teestore"
-
 	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
 )
 
@@ -45,19 +43,28 @@ type EventParameters struct {
 	BillingMetadata *EventBillingMetadata
 }
 
+type EventsStore interface {
+	StoreEvents(context.Context, []*telemetrygatewayv1.Event) error
+}
+
 // EventRecorder is for creating and recording telemetry events in the backend
 // using Telemetry V2, which exports events to Sourcergraph.
-type EventRecorder struct{ teestore teestore.Store }
+type EventRecorder struct{ store EventsStore }
 
-// ❗ Experimental - do not use!
-func NewEventRecorder(store teestore.Store) *EventRecorder {
-	return &EventRecorder{teestore: store}
+// NewEventRecorder creates a custom event recorder backed by a store
+// implementation. In general, prefer to use the telemetryrecorder.New()
+// constructor instead.
+//
+// If you don't care about event recording failures, consider using a
+// BestEffortEventRecorder instead.
+func NewEventRecorder(store EventsStore) *EventRecorder {
+	return &EventRecorder{store: store}
 }
 
 // Record records a single telemetry event with the context's Sourcegraph
 // actor.
 func (r *EventRecorder) Record(ctx context.Context, feature eventFeature, action eventAction, parameters EventParameters) error {
-	return r.teestore.StoreEvents(ctx, []*telemetrygatewayv1.Event{
+	return r.store.StoreEvents(ctx, []*telemetrygatewayv1.Event{
 		newTelemetryGatewayEvent(ctx, time.Now(), telemetrygatewayv1.DefaultEventIDFunc, feature, action, parameters),
 	})
 }
@@ -72,5 +79,5 @@ func (r *EventRecorder) BatchRecord(ctx context.Context, events ...Event) error
 	for i, e := range events {
 		rawEvents[i] = newTelemetryGatewayEvent(ctx, time.Now(), telemetrygatewayv1.DefaultEventIDFunc, e.Feature, e.Action, e.Parameters)
 	}
-	return r.teestore.StoreEvents(ctx, rawEvents)
+	return r.store.StoreEvents(ctx, rawEvents)
 }
diff --git a/internal/telemetry/telemetry_test.go b/internal/telemetry/telemetry_test.go
index ac931130019..f39676e746b 100644
--- a/internal/telemetry/telemetry_test.go
+++ b/internal/telemetry/telemetry_test.go
@@ -64,4 +64,17 @@ func TestRecorderEndToEnd(t *testing.T) {
 		require.NoError(t, err)
 		assert.Len(t, telemetryEvents, wantEvents)
 	})
+
+	t.Run("record without v1", func(t *testing.T) {
+		ctx := teestore.WithoutV1(ctx)
+		assert.NoError(t, recorder.Record(ctx, "Test", "Action1", telemetry.EventParameters{}))
+
+		telemetryEvents, err := db.TelemetryEventsExportQueue().ListForExport(ctx, 999)
+		require.NoError(t, err)
+		assert.Len(t, telemetryEvents, wantEvents+1)
+
+		eventLogs, err := db.EventLogs().ListAll(ctx, database.EventLogsListOptions{UserID: userID})
+		require.NoError(t, err)
+		assert.Len(t, eventLogs, wantEvents) // v1 unchanged
+	})
 }
diff --git a/internal/telemetry/telemetryrecorder/BUILD.bazel b/internal/telemetry/telemetryrecorder/BUILD.bazel
new file mode 100644
index 00000000000..8eaa60e5cb4
--- /dev/null
+++ b/internal/telemetry/telemetryrecorder/BUILD.bazel
@@ -0,0 +1,14 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "telemetryrecorder",
+    srcs = ["telemetryrecorder.go"],
+    importpath = "github.com/sourcegraph/sourcegraph/internal/telemetry/telemetryrecorder",
+    visibility = ["//:__subpackages__"],
+    deps = [
+        "//internal/database",
+        "//internal/telemetry",
+        "//internal/telemetry/teestore",
+        "@com_github_sourcegraph_log//:log",
+    ],
+)
diff --git a/internal/telemetry/telemetryrecorder/telemetryrecorder.go b/internal/telemetry/telemetryrecorder/telemetryrecorder.go
new file mode 100644
index 00000000000..1624e830c71
--- /dev/null
+++ b/internal/telemetry/telemetryrecorder/telemetryrecorder.go
@@ -0,0 +1,34 @@
+// Package telemetryrecorder provides default constructors for telemetry
+// recorders.
+//
+// This package partly exists to avoid dependency cycles with the database
+// package and the telemetry package.
+package telemetryrecorder
+
+import (
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/internal/database"
+	"github.com/sourcegraph/sourcegraph/internal/telemetry"
+	"github.com/sourcegraph/sourcegraph/internal/telemetry/teestore"
+)
+
+// New creates a default EventRecorder for Telemetry V2, which exports recorded
+// events to Sourcegraph's Telemetry Gateway service.
+//
+// The current defaults tee events to both the legacy event_logs table, as well
+// as the new Telemetry Gateway export queue.
+func New(db database.DB) *telemetry.EventRecorder {
+	return telemetry.NewEventRecorder(teestore.NewStore(db.TelemetryEventsExportQueue(), db.EventLogs()))
+}
+
+// New creates a default BestEffortEventRecorder for Telemetry V2, which exports
+// recorded events to Sourcegraph's Telemetry Gateway service.
+//
+// The current defaults tee events to both the legacy event_logs table, as well
+// as the new Telemetry Gateway export queue.
+func NewBestEffort(logger log.Logger, db database.DB) *telemetry.BestEffortEventRecorder {
+	return telemetry.NewBestEffortEventRecorder(
+		logger.Scoped("telemetry", "telemetry event recorder"),
+		New(db))
+}
diff --git a/internal/telemetrygateway/BUILD.bazel b/internal/telemetrygateway/BUILD.bazel
index e69de29bb2d..368a9e7c760 100644
--- a/internal/telemetrygateway/BUILD.bazel
+++ b/internal/telemetrygateway/BUILD.bazel
@@ -0,0 +1,24 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "telemetrygateway",
+    srcs = [
+        "exporter.go",
+        "identifier.go",
+    ],
+    importpath = "github.com/sourcegraph/sourcegraph/internal/telemetrygateway",
+    visibility = ["//:__subpackages__"],
+    deps = [
+        "//internal/conf/conftypes",
+        "//internal/env",
+        "//internal/grpc/chunk",
+        "//internal/grpc/defaults",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//internal/trace",
+        "//lib/errors",
+        "@com_github_google_uuid//:uuid",
+        "@com_github_sourcegraph_log//:log",
+        "@io_opentelemetry_go_otel//attribute",
+        "@org_golang_google_grpc//:go_default_library",
+    ],
+)
diff --git a/internal/telemetrygateway/exporter.go b/internal/telemetrygateway/exporter.go
new file mode 100644
index 00000000000..6552d2ea7f2
--- /dev/null
+++ b/internal/telemetrygateway/exporter.go
@@ -0,0 +1,175 @@
+package telemetrygateway
+
+import (
+	"context"
+	"io"
+	"net/url"
+
+	"go.opentelemetry.io/otel/attribute"
+	"google.golang.org/grpc"
+
+	"github.com/google/uuid"
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/internal/conf/conftypes"
+	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/grpc/chunk"
+	"github.com/sourcegraph/sourcegraph/internal/grpc/defaults"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+	"github.com/sourcegraph/sourcegraph/internal/trace"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type Exporter interface {
+	ExportEvents(context.Context, []*telemetrygatewayv1.Event) ([]string, error)
+	Close() error
+}
+
+func NewExporter(ctx context.Context, logger log.Logger, c conftypes.SiteConfigQuerier, exportAddress string) (Exporter, error) {
+	u, err := url.Parse(exportAddress)
+	if err != nil {
+		return nil, errors.Wrap(err, "invalid export address")
+	}
+
+	insecureTarget := u.Scheme != "https"
+	if insecureTarget && !env.InsecureDev {
+		return nil, errors.Wrap(err, "insecure export address used outside of dev mode")
+	}
+
+	// TODO(@bobheadxi): Maybe don't use defaults.DialOptions etc, which are
+	// geared towards in-Sourcegraph services.
+	var opts []grpc.DialOption
+	if insecureTarget {
+		opts = defaults.DialOptions(logger)
+	} else {
+		opts = defaults.ExternalDialOptions(logger)
+	}
+	conn, err := grpc.DialContext(ctx, u.Host, opts...)
+	if err != nil {
+		return nil, errors.Wrap(err, "dialing telemetry gateway")
+	}
+
+	return &exporter{
+		client: telemetrygatewayv1.NewTelemeteryGatewayServiceClient(conn),
+		conf:   c,
+		conn:   conn,
+	}, nil
+}
+
+type exporter struct {
+	client telemetrygatewayv1.TelemeteryGatewayServiceClient
+	conf   conftypes.SiteConfigQuerier
+	conn   *grpc.ClientConn
+}
+
+func (e *exporter) ExportEvents(ctx context.Context, events []*telemetrygatewayv1.Event) ([]string, error) {
+	tr, ctx := trace.New(ctx, "ExportEvents", attribute.Int("events", len(events)))
+	defer tr.End()
+
+	identifier, err := newIdentifier(e.conf)
+	if err != nil {
+		tr.SetError(err)
+		return nil, err
+	}
+
+	var requestID string
+	if tr.IsRecording() {
+		requestID = tr.SpanContext().TraceID().String()
+	} else {
+		requestID = uuid.NewString()
+	}
+
+	succeeded, err := e.doExportEvents(ctx, requestID, identifier, events)
+	if err != nil {
+		tr.SetError(err)
+		// Surface request ID to help us correlate log entries more easily on
+		// our end, because Telemetry Gateway doesn't return granular failure
+		// details.
+		return succeeded, errors.Wrapf(err, "request %q", requestID)
+	}
+	return succeeded, nil
+}
+
+// doExportEvents makes it easier for us to wrap all errors in our request ID
+// for ease of investigating failures.
+func (e *exporter) doExportEvents(
+	ctx context.Context,
+	requestID string,
+	identifier *telemetrygatewayv1.Identifier,
+	events []*telemetrygatewayv1.Event,
+) ([]string, error) {
+	// Start the stream
+	stream, err := e.client.RecordEvents(ctx)
+	if err != nil {
+		return nil, errors.Wrap(err, "start export")
+	}
+
+	// Send initial metadata
+	if err := stream.Send(&telemetrygatewayv1.RecordEventsRequest{
+		Payload: &telemetrygatewayv1.RecordEventsRequest_Metadata{
+			Metadata: &telemetrygatewayv1.RecordEventsRequestMetadata{
+				RequestId:  requestID,
+				Identifier: identifier,
+			},
+		},
+	}); err != nil {
+		return nil, errors.Wrap(err, "send initial metadata")
+	}
+
+	// Set up a callback that makes sure we pick up all responses from the
+	// server.
+	collectResults := func() ([]string, error) {
+		// We're collecting results now - end the request send stream. From here,
+		// the server will eventually get io.EOF and return, then we will eventually
+		// get an io.EOF and return. Discard the error because we don't really
+		// care - in examples, the error gets discarded as well:
+		// https://github.com/grpc/grpc-go/blob/130bc4281c39ac1ed287ec988364d36322d3cd34/examples/route_guide/client/client.go#L145
+		//
+		// If anything goes wrong stream.Recv() will let us know.
+		_ = stream.CloseSend()
+
+		// Wait for responses from server.
+		succeededEvents := make([]string, 0, len(events))
+		for {
+			resp, err := stream.Recv()
+			if errors.Is(err, io.EOF) {
+				break
+			}
+			if err != nil {
+				return succeededEvents, err
+			}
+			if len(resp.GetSucceededEvents()) > 0 {
+				succeededEvents = append(succeededEvents, resp.GetSucceededEvents()...)
+			}
+		}
+		if len(succeededEvents) < len(events) {
+			return succeededEvents, errors.Newf("%d events did not get recorded successfully",
+				len(events)-len(succeededEvents))
+		}
+		return succeededEvents, nil
+	}
+
+	// Start streaming our set of events, chunking them based on message size
+	// as determined internally by chunk.Chunker.
+	chunker := chunk.New(func(chunkedEvents []*telemetrygatewayv1.Event) error {
+		return stream.Send(&telemetrygatewayv1.RecordEventsRequest{
+			Payload: &telemetrygatewayv1.RecordEventsRequest_Events{
+				Events: &telemetrygatewayv1.RecordEventsRequest_EventsPayload{
+					Events: chunkedEvents,
+				},
+			},
+		})
+	})
+	if err := chunker.Send(events...); err != nil {
+		succeeded, _ := collectResults()
+		return succeeded, errors.Wrap(err, "chunk and send events")
+	}
+	if err := chunker.Flush(); err != nil {
+		succeeded, _ := collectResults()
+		return succeeded, errors.Wrap(err, "flush events")
+	}
+
+	return collectResults()
+}
+
+func (e *exporter) Close() error { return e.conn.Close() }
diff --git a/internal/telemetrygateway/identifier.go b/internal/telemetrygateway/identifier.go
new file mode 100644
index 00000000000..d3448b6982b
--- /dev/null
+++ b/internal/telemetrygateway/identifier.go
@@ -0,0 +1,23 @@
+package telemetrygateway
+
+import (
+	"github.com/sourcegraph/sourcegraph/internal/conf/conftypes"
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+func newIdentifier(c conftypes.SiteConfigQuerier) (*telemetrygatewayv1.Identifier, error) {
+	if lk := c.SiteConfig().LicenseKey; lk != "" {
+		return &telemetrygatewayv1.Identifier{
+			Identifier: &telemetrygatewayv1.Identifier_LicensedInstance{
+				LicensedInstance: &telemetrygatewayv1.Identifier_LicensedInstanceIdentifier{
+					LicenseKey: lk,
+				},
+			},
+		}, nil
+	}
+
+	// TODO: Add support for unlicensed instances
+
+	return nil, errors.New("cannot infer an identifer for this instance")
+}
diff --git a/internal/telemetrygateway/v1/BUILD.bazel b/internal/telemetrygateway/v1/BUILD.bazel
index e4aa411cae6..508b93db7fa 100644
--- a/internal/telemetrygateway/v1/BUILD.bazel
+++ b/internal/telemetrygateway/v1/BUILD.bazel
@@ -34,12 +34,16 @@ go_library(
     importpath = "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1",
     visibility = [
         "//cmd/frontend/internal/telemetry/resolvers:__pkg__",
+        "//cmd/telemetry-gateway/internal/events:__pkg__",
+        "//cmd/telemetry-gateway/internal/server:__pkg__",
+        "//cmd/telemetry-gateway/shared:__pkg__",
         "//cmd/telemetrygateway/server:__pkg__",
         "//cmd/telemetrygateway/shared:__pkg__",
         "//internal/api:__pkg__",
         "//internal/database:__pkg__",
         "//internal/extsvc/gitolite:__pkg__",
         "//internal/telemetry:__pkg__",
+        "//internal/telemetry/sensitivemetadataallowlist:__pkg__",
         "//internal/telemetry/teestore:__pkg__",
         "//internal/telemetrygateway:__pkg__",
         "//internal/telemetrygateway/gitdomain:__pkg__",
diff --git a/lib/pointers/ptr.go b/lib/pointers/ptr.go
index f6fcd204e61..89e594048ad 100644
--- a/lib/pointers/ptr.go
+++ b/lib/pointers/ptr.go
@@ -15,7 +15,7 @@ func NonZeroPtr[T comparable](val T) *T {
 	return Ptr(val)
 }
 
-// Deref safely dereferences a pointer. If pointer is nil, returns zero value,
+// Deref safely dereferences a pointer. If pointer is nil, returns default value,
 // otherwise returns dereferenced value.
 func Deref[T any](v *T, defaultValue T) T {
 	if v != nil {
